
#include <stdlib.h>
#include <gtk/gtk.h>
#include <libxfcegui4/libxfcegui4.h>

void save_yourself (gpointer client_data, int save_style, gboolean shutdown, int interact_style, gboolean fast)
{
    g_print ("Saving file %s (not for real, hehehe :)\n", (char *) client_data);
}

void hello(GtkWidget * widget, gpointer data)
{
    g_print("Hello World\n");
}

gint delete_event(GtkWidget * widget, GdkEvent * event, gpointer data)
{
    g_print("delete event occurred\n");
    return TRUE;
}

/* Another callback */
void destroy(GtkWidget * widget, gpointer data)
{
    gtk_main_quit();
}

int main(int argc, char *argv[])
{
    SessionClient *client_session;
    GtkWidget *window;
    GtkWidget *button;

    gtk_init(&argc, &argv);

    client_session = client_session_new(argc, argv, "test" /* data */ , SESSION_RESTART_IF_RUNNING, 50);

    client_session->save_yourself = save_yourself;

    if(!session_init(client_session))
    {
        g_message("Cannot connect to session manager");
        exit(0);
    }

    /* create a new window */
    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

    g_signal_connect(G_OBJECT(window), "delete_event", G_CALLBACK(delete_event), NULL);

    g_signal_connect(G_OBJECT(window), "destroy", G_CALLBACK(destroy), NULL);

    gtk_container_set_border_width(GTK_CONTAINER(window), 10);

    button = gtk_button_new_with_label("Hello World");

    g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(hello), NULL);

    g_signal_connect_swapped(G_OBJECT(button), "clicked", G_CALLBACK(gtk_widget_destroy), window);

    gtk_container_add(GTK_CONTAINER(window), button);

    gtk_widget_show(button);

    gtk_widget_show(window);

    gtk_main();

    return 0;
}
